#include <multos.h>

#pragma melstatic
static BYTE abADC1[] = {
		0x01,0x11,0x44,0x01,0x00,0x00,0x00,0x00,0x09,0xb4,0x47,0x03,0x00,0x03,0x00,0x00,
		0x48,0x00,0x80,0x00,0x00,0x01,0x03,0x00,0x00,0x00,0xff,0xff,0xff,0xff,0xff,0xff,
		0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,
		0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0x12,0x00,0x00,0x05,0xff,0xff,
		0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,
		0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0x00,0x00,
		0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x01,0x00,
		0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x01,0x04,0xf0,0x00,0x00,0xff,0xff,0xff,0xff,
		0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0x00,0x00,0x00,0x00,0x00,0x00,0x00
};

static BYTE abADC2[] = {
		0x00,0xa9,0x3f,0xa7,0x67,0x14,0xe6,0x9e,0x6e,0x49,0xb5,0xf2,0xec,0x4a,0x5c,0xd1,
		0x0f,0x7f,0x07,0x60,0x26,0x68,0x33,0xff,0x5a,0x77,0xf7,0xc7,0x22,0x37,0x41,0x0c,
		0xe9,0x6b,0xfa,0x2a,0xd1,0xe8,0x8b,0x8d,0x23,0x97,0x21,0x8e,0xc9,0x21,0x82,0x0e,
		0x22,0x7d,0xaf,0x23,0xfc,0x50,0x9c,0x1b,0x29,0x5b,0x1d,0x07,0x09,0x76,0x12,0xce,
		0x47,0xd6,0x0e,0x11,0x11,0xdc,0xd5,0x0d,0xd5,0xd2,0x33,0x62,0x2c,0x88,0x60,0x10,
		0xd0,0xf5,0x64,0xf1,0x58,0xae,0x5a,0xe2,0x6f,0x32,0x7b,0xfd,0xad,0x8c,0xfa,0x79,
		0x17,0x07,0x28,0xb2,0x02,0x0b,0x2d,0xeb,0x62,0x9c,0xb4,0x43,0xfd,0x47,0x02,0xae,
		0x5e,0x72,0xa3,0xf1,0x1f,0x5c,0xe2,0xdc,0xd5,0xb0,0x6f,0xb1,0xbf,0x09,0x4c,0x44,
		0xd4
};

static BOOL fDeleting = FALSE;

static void sendDeleteCmd(BYTE *bData, BYTE bLen, BYTE *pPub)
{
	// Set up the Delete MEL Application APDU in public
	multosCLA = 0xBE;
	multosINS = 0x18;
	multosP1 = 0;
	multosP2 = 0;
	multosLc = bLen;

    multosProtocolFlags &= ~0x01; /* Reset P3 valid */
    multosProtocolFlags |= 0x02; /* Set Lc valid */
    multosProtocolFlags &= ~0x04; /* Reset Le valid */

    // Add the data
	multosCopy(bData,pPub,bLen);

	// Flag to MULTOS to restart the app after processing the command
	multosExitToMultosAndRestart();

	// Exit back to MULTOS
	multosExit();
}

 void checkForDelete (BYTE *pPub)
 {
	 /* If part way through the delete */
	 if (fDeleting)
	 {
		 // Send the second part of the ADC. This should result in the app being deleted.
		 sendDeleteCmd(abADC2,sizeof(abADC2), pPub);
	 }
	 /* If the command is the delete self command */
	 else if (CLA == 0xBB && INS == 0x00)
	 {
		 // Flag delete process has started
		 fDeleting = TRUE;

		 // Send first part of ADC
		 sendDeleteCmd(abADC1,sizeof(abADC1), pPub);
	 }
 }

